diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererPiston.java b/src/main/java/net/minecraft/client/render/blockentity/PistonBlockEntityRenderer.java
similarity index 59%
rename from src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererPiston.java
rename to src/main/java/net/minecraft/client/render/blockentity/PistonBlockEntityRenderer.java
index 4eab6bba9..b595aab41 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererPiston.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/PistonBlockEntityRenderer.java
@@ -1,33 +1,34 @@
-package net.minecraft.client.render.tileentity;
+package net.minecraft.client.render.blockentity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.block.model.BlockModelPiston;
-import net.minecraft.client.render.block.model.BlockModelPistonHead;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.block.model.PistonBlockModel;
+import net.minecraft.client.render.block.model.PistonHeadBlockModel;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.piston.BlockPistonBase;
-import net.minecraft.core.block.piston.BlockPistonHead;
-import net.minecraft.core.block.piston.TileEntityPistonMoving;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.piston.BasePistonBlock;
+import net.minecraft.core.block.piston.MovingPistonBlockEntity;
+import net.minecraft.core.block.piston.PistonHeadBlock;
 import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
 //            TileEntitySpecialRenderer, Block, TileEntityPiston, Tessellator,
-//            RenderHelper, RenderBlocks, BlockPistonBase, BlockPistonExtension, 
-//            World, TileEntity
+//            RenderHelper, RenderBlocks, BasePistonBlock, BlockPistonExtension,
+//            World, BlockEntity
 
-public class TileEntityRendererPiston extends TileEntityRenderer<TileEntityPistonMoving>
+public class PistonBlockEntityRenderer extends BlockEntityRenderer<MovingPistonBlockEntity>
 {
-    private static final BlockModelPistonHead blockModelPistonHead = (BlockModelPistonHead) BlockModelDispatcher.getInstance().getDispatch(Block.pistonHead);
+    private static final PistonHeadBlockModel blockModelPistonHead = (PistonHeadBlockModel) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD);
     private RenderBlocks renderBlocks;
     private final Minecraft mc;
 
-    public TileEntityRendererPiston()
+    public PistonBlockEntityRenderer()
     {
         mc = Minecraft.getMinecraft(this);
     }
@@ -39,39 +40,39 @@ public class TileEntityRendererPiston extends TileEntityRenderer<TileEntityPisto
     }
 
     @Override
-	public void doRender(Tessellator tessellator, TileEntityPistonMoving tileEntity, double x, double y, double z,
+	public void doRender(Tessellator tessellator, MovingPistonBlockEntity tileEntity, double x, double y, double z,
                          float partialTick)
     {
         Block block = Block.blocksList[tileEntity.getMovedId()];
         if(block != null && tileEntity.getProgress(partialTick) < 1.0F)
         {
-            TextureRegistry.blockAtlas.bindTexture();
+            TextureRegistry.blockAtlas.bind();
             Lighting.disable();
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            GL11.glEnable(3042 /*GL_BLEND*/);
-            GL11.glDisable(2884 /*GL_CULL_FACE*/);
+            GL11.glEnable(GL11.GL_BLEND);
+            GL11.glDisable(GL11.GL_CULL_FACE);
             if(mc.isAmbientOcclusionEnabled())
             {
-                GL11.glShadeModel(7425 /*GL_SMOOTH*/);
+                GL11.glShadeModel(GL11.GL_SMOOTH);
             } else
             {
-                GL11.glShadeModel(7424 /*GL_FLAT*/);
+                GL11.glShadeModel(GL11.GL_FLAT);
             }
             tessellator.startDrawingQuads();
             tessellator.setTranslation(((float)x - (float)tileEntity.x) + tileEntity.getXOff(partialTick), ((float)y - (float)tileEntity.y) + tileEntity.getYOff(partialTick), ((float)z - (float)tileEntity.z) + tileEntity.getZOff(partialTick));
             tessellator.setColorOpaque(1, 1, 1);
-            if(block == Block.pistonHead && tileEntity.getProgress(partialTick) < 0.5F)
+            if(block == Blocks.PISTON_HEAD && tileEntity.getProgress(partialTick) < 0.5F)
             {
                 BlockModel.setRenderBlocks(renderBlocks);
-                blockModelPistonHead.renderPistonHeadNoCulling(tessellator, (BlockPistonHead) block, tileEntity.x, tileEntity.y, tileEntity.z, false);
+                blockModelPistonHead.renderPistonHeadNoCulling(tessellator, (PistonHeadBlock) block, tileEntity.x, tileEntity.y, tileEntity.z, false);
             } else
             if(tileEntity.isSourcePiston() && !tileEntity.isExtending())
             {
-                BlockModelPiston<BlockPistonBase> pistonBase = (BlockModelPiston) BlockModelDispatcher.getInstance().getDispatch(block);
-                ((BlockPistonHead)Block.pistonHead).setFaceTexture(pistonBase.getFaceTexture());
+                PistonBlockModel<BasePistonBlock> pistonBase = (PistonBlockModel) BlockModelDispatcher.getInstance().getDispatch(block);
                 BlockModel.setRenderBlocks(renderBlocks);
-                blockModelPistonHead.renderPistonHeadNoCulling(tessellator, (BlockPistonHead) Block.pistonHead, tileEntity.x, tileEntity.y, tileEntity.z, tileEntity.getProgress(partialTick) < 0.5F);
-                ((BlockPistonHead)Block.pistonHead).resetFace();
+                blockModelPistonHead.setFaceTextureOverride(pistonBase.getFaceTexture());
+                blockModelPistonHead.renderPistonHeadNoCulling(tessellator, (PistonHeadBlock) Blocks.PISTON_HEAD, tileEntity.x, tileEntity.y, tileEntity.z, tileEntity.getProgress(partialTick) < 0.5F);
+                blockModelPistonHead.setFaceTextureOverride(null);
                 tessellator.setTranslation((float)x - (float)tileEntity.x, (float)y - (float)tileEntity.y, (float)z - (float)tileEntity.z);
                 pistonBase.renderNoCulling(tessellator, tileEntity.x, tileEntity.y, tileEntity.z);
             } else
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
similarity index 58%
rename from src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
rename to src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
index 8cb5e9ab4..417b93bf0 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
@@ -1,41 +1,46 @@
-package net.minecraft.client.render.tileentity;
+package net.minecraft.client.render.blockentity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.model.ModelSign;
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.model.SignModel;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntitySign;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.SignBlockEntity;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            TileEntitySpecialRenderer, SignModel, TileEntitySign, Block, 
-//            ModelRenderer, FontRenderer, TileEntity
+//            TileEntitySpecialRenderer, SignModel, SignBlockEntity, Block,
+//            ModelRenderer, FontRenderer, BlockEntity
 
-public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
+public class SignBlockEntityRenderer extends BlockEntityRenderer<SignBlockEntity>
 {
 
 	private final Minecraft mc = Minecraft.getMinecraft(this);
 	
-    public TileEntityRendererSign()
+    public SignBlockEntityRenderer()
     {
-        signModel = new ModelSign();
+        signModel = new SignModel();
     }
 
-    public void renderTileEntitySignAt(TileEntitySign tileEntity, double d, double d1, double d2,
+    public void renderTileEntitySignAt(SignBlockEntity tileEntity, double d, double d1, double d2,
                                        float f)
     {
         Block block = tileEntity.getBlockType();
         GL11.glPushMatrix();
         float scale = 0.6666667F;
-        if(block == Block.signPostPlanksOak)
+        if(block == Blocks.SIGN_POST_PLANKS_OAK)
         {
             GL11.glTranslatef((float)d + 0.5F, (float)d1 + 0.75F * scale, (float)d2 + 0.5F);
             float f2 = (float)(tileEntity.getMovedData() * 360) / 16F;
             GL11.glRotatef(-f2, 0.0F, 1.0F, 0.0F);
-            signModel.signStick.showModel = true;
+            signModel.signStick.visible = true;
         }
         else
         {
@@ -59,7 +64,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
             GL11.glTranslatef((float)d + 0.5F, (float)d1 + 0.75F * scale, (float)d2 + 0.5F);
             GL11.glRotatef(-f3, 0.0F, 1.0F, 0.0F);
             GL11.glTranslatef(0.0F, -0.3125F, -0.4375F);
-            signModel.signStick.showModel = false;
+            signModel.signStick.visible = false;
         }
         loadTexture("/assets/minecraft/textures/entity/sign.png");
         GL11.glPushMatrix();
@@ -76,12 +81,20 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         GL11.glNormal3f(0.0F, 0.0F, -1F * f4);
         GL11.glDepthMask(false);
         EnumSignPicture picture = tileEntity.getPicture();
-        renderDispatcher.renderEngine.bindTexture(renderDispatcher.renderEngine.getTexture("/assets/minecraft/textures/gui/sign_images.png"));
-        drawTexturedModalRect(-48, -24, picture.getU(), picture.getV(), 48, 24);
+        drawTexturedModalRect(-48, -24, 48, 24, TextureRegistry.getTexture(picture.getTextureKey()));
         GL11.glPopMatrix();
         
         // Render text
         float lightLevel = mc.theWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
+        float lightOffset = 0f;
+        if (tileEntity.isGlowing()) {
+            lightLevel = 1f;
+            lightOffset = 96f;
+            GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+            if(LightmapHelper.isLightmapEnabled()) {
+                LightmapHelper.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
+            }
+        }
         
         GL11.glPushMatrix();
         f4 = 0.01666667F * scale;
@@ -90,9 +103,9 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         GL11.glNormal3f(0.0F, 0.0F, -1F * f4);
         GL11.glDepthMask(false);
         int color = Colors.allSignColors[tileEntity.getColor().id].getARGB();
-        int r = (int)(((color >> 16) & 0xFF) * lightLevel);
-        int g = (int)(((color >>  8) & 0xFF) * lightLevel);
-        int b = (int)(((color >>  0) & 0xFF) * lightLevel);
+        int r = (int)MathHelper.clamp(((color >> 16) & 0xFF) * lightLevel + lightOffset, 0, 255);
+        int g = (int)MathHelper.clamp(((color >>  8) & 0xFF) * lightLevel + lightOffset, 0, 255);
+        int b = (int)MathHelper.clamp(((color >>  0) & 0xFF) * lightLevel + lightOffset, 0, 255);
         color = (r << 16) | (g << 8) | (b << 0);
         for(int line = 0; line < tileEntity.signText.length; line++)
         {
@@ -111,25 +124,24 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
     }
 
     @Override
-	public void doRender(Tessellator tessellator, TileEntitySign tileEntity, double x, double y, double z,
+	public void doRender(Tessellator tessellator, SignBlockEntity tileEntity, double x, double y, double z,
                          float partialTick)
     {
         renderTileEntitySignAt(tileEntity, x, y, z, partialTick);
     }
 
-    private void drawTexturedModalRect(int x, int y, int u, int v, int width, int height)
+    private void drawTexturedModalRect(int x, int y, int width, int height, IconCoordinate coordinate)
     {
-        float uScale = 1 / 768F;
-        float vScale = 1 / 384F;
+        coordinate.parentAtlas.bind();
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x + 0, y + height * 2, 0, (float)(u + 0) * uScale, (float)(v + height) * vScale);
-        tessellator.addVertexWithUV(x + width * 2, y + height * 2, 0, (float)(u + width) * uScale, (float)(v + height) * vScale);
-        tessellator.addVertexWithUV(x + width * 2, y + 0, 0, (float)(u + width) * uScale, (float)(v + 0) * vScale);
-        tessellator.addVertexWithUV(x + 0, y + 0, 0, (float)(u + 0) * uScale, (float)(v + 0) * vScale);
+        tessellator.addVertexWithUV(x + 0,          y + height * 2, 0, coordinate.getIconUMin(),coordinate.getIconVMax());
+        tessellator.addVertexWithUV(x + width * 2,  y + height * 2, 0, coordinate.getIconUMax(),coordinate.getIconVMax());
+        tessellator.addVertexWithUV(x + width * 2,  y + 0,          0, coordinate.getIconUMax(),coordinate.getIconVMin());
+        tessellator.addVertexWithUV(x + 0,          y + 0,          0, coordinate.getIconUMin(),coordinate.getIconVMin());
         tessellator.draw();
     }
 
 
-    private final ModelSign signModel;
+    private final SignModel signModel;
 }
diff --git a/src/main/java/net/minecraft/client/render/camera/CameraUtil.java b/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
index 8d9e41766..9c55f6705 100644
--- a/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
+++ b/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
@@ -1,33 +1,33 @@
 package net.minecraft.client.render.camera;
 
-import net.minecraft.core.HitResult;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
+import net.minecraft.core.block.FluidBlock;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 
 public abstract class CameraUtil
 {
     public static HitResult traceRay(ICamera camera, World world, double distance, float partialTick)
     {
-        Vec3d pos = camera.getPosition(partialTick);
-        Vec3d rot = camera.getRotationVector(partialTick);
-        Vec3d endPos = pos.addVector(rot.xCoord * distance, rot.yCoord * distance, rot.zCoord * distance);
+        Vec3 pos = camera.getPosition(partialTick);
+        Vec3 rot = camera.getRotationVector(partialTick);
+        Vec3 endPos = pos.add(rot.x * distance, rot.y * distance, rot.z * distance);
         return world.checkBlockCollisionBetweenPoints(pos, endPos);
     }
 
     public static boolean isUnderLiquid(ICamera camera, World world, Material material, float partialTick)
     {
         double cameraY = camera.getY(partialTick);
-        int x = MathHelper.floor_double(camera.getX(partialTick));
-        int y = MathHelper.floor_float(MathHelper.floor_double(cameraY));
-        int z = MathHelper.floor_double(camera.getZ(partialTick));
+        int x = MathHelper.floor(camera.getX(partialTick));
+        int y = MathHelper.floor_float(MathHelper.floor(cameraY));
+        int z = MathHelper.floor(camera.getZ(partialTick));
         int id = world.getBlockId(x, y, z);
         if(id != 0 && Block.blocksList[id].blockMaterial == material)
         {
-            float f = BlockFluid.getWaterVolume(world.getBlockMetadata(x, y, z)) - 0.2F;
+            float f = FluidBlock.getWaterVolume(world.getBlockMetadata(x, y, z)) - 0.2F;
             float f1 = (float)(y + 1) - f;
             return cameraY < (double)f1;
         }
diff --git a/src/main/java/net/minecraft/client/render/camera/EntityCamera.java b/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
index fa1ec3719..ca37c06a4 100644
--- a/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
+++ b/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
@@ -2,7 +2,7 @@ package net.minecraft.client.render.camera;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.culling.CameraFrustum;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 
 public abstract class EntityCamera
     implements ICamera
@@ -11,12 +11,12 @@ public abstract class EntityCamera
 
     private final CameraFrustum frustum;
 
-    public final EntityLiving entity;
+    public final Mob mob;
 
-    public EntityCamera(Minecraft mc, EntityLiving entity)
+    public EntityCamera(Minecraft mc, Mob mob)
     {
         this.mc = mc;
-        this.entity = entity;
+        this.mob = mob;
         this.frustum = new CameraFrustum(this);
     }
 
@@ -37,11 +37,11 @@ public abstract class EntityCamera
     {
         if (partialTick == 1f)
         {
-            return entity.x;
+            return mob.x;
         }
         else
         {
-            return entity.xo + (entity.x - entity.xo) * partialTick;
+            return mob.xo + (mob.x - mob.xo) * partialTick;
         }
     }
 
@@ -50,11 +50,11 @@ public abstract class EntityCamera
     {
         if (partialTick == 1f)
         {
-            return entity.y;
+            return mob.y;
         }
         else
         {
-            return (entity.yo + (entity.y - entity.yo) * partialTick);
+            return (mob.yo + (mob.y - mob.yo) * partialTick);
         }
     }
 
@@ -63,11 +63,11 @@ public abstract class EntityCamera
     {
         if (partialTick == 1f)
         {
-            return entity.z;
+            return mob.z;
         }
         else
         {
-            return entity.zo + (entity.z - entity.zo) * partialTick;
+            return mob.zo + (mob.z - mob.zo) * partialTick;
         }
 
     }
@@ -77,11 +77,11 @@ public abstract class EntityCamera
     {
         if (partialTick == 1f)
         {
-            return entity.xRot;
+            return mob.xRot;
         }
         else
         {
-            return entity.xRotO + (entity.xRot - entity.xRotO) * partialTick;
+            return mob.xRotO + (mob.xRot - mob.xRotO) * partialTick;
         }
 
     }
@@ -91,11 +91,11 @@ public abstract class EntityCamera
     {
         if (partialTick == 1f)
         {
-            return entity.yRot;
+            return mob.yRot;
         }
         else
         {
-            return entity.yRotO + (entity.yRot - entity.yRotO) * partialTick;
+            return mob.yRotO + (mob.yRot - mob.yRotO) * partialTick;
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/camera/EntityCameraFirstPerson.java b/src/main/java/net/minecraft/client/render/camera/EntityCameraFirstPerson.java
index 9cdbb50bb..bdd478b5f 100644
--- a/src/main/java/net/minecraft/client/render/camera/EntityCameraFirstPerson.java
+++ b/src/main/java/net/minecraft/client/render/camera/EntityCameraFirstPerson.java
@@ -1,12 +1,12 @@
 package net.minecraft.client.render.camera;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 
 public class EntityCameraFirstPerson
     extends EntityCamera
 {
-    public EntityCameraFirstPerson(Minecraft mc, EntityLiving entity)
+    public EntityCameraFirstPerson(Minecraft mc, Mob entity)
     {
         super(mc, entity);
     }
diff --git a/src/main/java/net/minecraft/client/render/camera/EntityCameraIsometric.java b/src/main/java/net/minecraft/client/render/camera/EntityCameraIsometric.java
index 4a387ffb8..59fb70b86 100644
--- a/src/main/java/net/minecraft/client/render/camera/EntityCameraIsometric.java
+++ b/src/main/java/net/minecraft/client/render/camera/EntityCameraIsometric.java
@@ -2,12 +2,12 @@ package net.minecraft.client.render.camera;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiPhotoMode;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 
 public class EntityCameraIsometric
     extends EntityCamera
 {
-    public EntityCameraIsometric(Minecraft mc, EntityLiving entity) {
+    public EntityCameraIsometric(Minecraft mc, Mob entity) {
         super(mc, entity);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java b/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
index 594485e7a..bd201d098 100644
--- a/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
+++ b/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
@@ -1,8 +1,7 @@
 package net.minecraft.client.render.camera;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.culling.CameraFrustum;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 
 public class EntityCameraSleeping
     extends EntityCamera
@@ -31,7 +30,7 @@ public class EntityCameraSleeping
     private final double xRotS;
     private final double xRotT;
 
-    public EntityCameraSleeping(Minecraft mc, EntityLiving entity, int xb, int yb, int zb, double xs, double ys, double zs, double yRotS, double xRotS)
+    public EntityCameraSleeping(Minecraft mc, Mob entity, int xb, int yb, int zb, double xs, double ys, double zs, double yRotS, double xRotS)
     {
         super(mc, entity);
         int metadata = mc.theWorld.getBlockMetadata(xb, yb, zb) & 3;
diff --git a/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonFront.java b/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonFront.java
index 9b6a1952c..dd9a71cd2 100644
--- a/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonFront.java
+++ b/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonFront.java
@@ -1,15 +1,12 @@
 package net.minecraft.client.render.camera;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.core.HitResult;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.entity.Mob;
 
 public class EntityCameraThirdPersonFront
         extends EntityCameraThirdPersonRear
 {
-    public EntityCameraThirdPersonFront(Minecraft mc, EntityLiving entity)
+    public EntityCameraThirdPersonFront(Minecraft mc, Mob entity)
     {
         super(mc, entity);
     }
diff --git a/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java b/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
index 22016f636..bb648f71e 100644
--- a/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
+++ b/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.render.camera;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.core.HitResult;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 
 public class EntityCameraThirdPersonRear
     extends EntityCamera
@@ -12,7 +12,7 @@ public class EntityCameraThirdPersonRear
     protected float lastpartialTick = 0f;
     protected double lastCameraDistance = 0d;
 
-    public EntityCameraThirdPersonRear(Minecraft mc, EntityLiving entity)
+    public EntityCameraThirdPersonRear(Minecraft mc, Mob entity)
     {
         super(mc, entity);
     }
@@ -44,19 +44,19 @@ public class EntityCameraThirdPersonRear
         double dz = (MathHelper.cos((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI));
         double dy = (-MathHelper.sin((xRot / 180F) * MathHelper.PI));
 
-        double cameraDistance = Vec3d.createVector(x, y, z).distanceTo(Vec3d.createVector(x - numSteps * dx, y - numSteps * dy, z - numSteps * dz)) - offset;
+        double cameraDistance = Vec3.getTempVec3(x, y, z).distanceTo(Vec3.getTempVec3(x - numSteps * dx, y - numSteps * dy, z - numSteps * dz)) - offset;
 
         for(int i = 0; i <= numSteps; i++)
         {
             HitResult hitResult = mc.theWorld.checkBlockCollisionBetweenPoints(
-                    Vec3d.createVector(x, y, z),
-                    Vec3d.createVector(x - i * dx, y - i * dy, z - i * dz),
+                    Vec3.getTempVec3(x, y, z),
+                    Vec3.getTempVec3(x - i * dx, y - i * dy, z - i * dz),
                     false,
                     true
             );
             if(hitResult != null)
             {
-                double distance = hitResult.location.distanceTo(Vec3d.createVector(x, y, z)) - offset;
+                double distance = hitResult.location.distanceTo(Vec3.getTempVec3(x, y, z)) - offset;
                 if (distance < 0) distance = 0;
                 cameraDistance = distance;
                 break;
diff --git a/src/main/java/net/minecraft/client/render/camera/ICamera.java b/src/main/java/net/minecraft/client/render/camera/ICamera.java
index 4b90aa004..f401c44f1 100644
--- a/src/main/java/net/minecraft/client/render/camera/ICamera.java
+++ b/src/main/java/net/minecraft/client/render/camera/ICamera.java
@@ -3,7 +3,7 @@ package net.minecraft.client.render.camera;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 
 public interface ICamera
 {
@@ -34,12 +34,12 @@ public interface ICamera
         return getZ(1f);
     }
 
-    default Vec3d getPosition(float partialTick)
+    default Vec3 getPosition(float partialTick)
     {
-        return Vec3d.createVector(getX(partialTick), getY(partialTick), getZ(partialTick));
+        return Vec3.getTempVec3(getX(partialTick), getY(partialTick), getZ(partialTick));
     }
 
-    default Vec3d getPosition()
+    default Vec3 getPosition()
     {
         return getPosition(1f);
     }
@@ -58,7 +58,7 @@ public interface ICamera
         return getYRot(1f);
     }
 
-    default Vec3d getViewVector(float partialTick)
+    default Vec3 getViewVector(float partialTick)
     {
         float xRot = (float) getXRot(partialTick);
         float yRot = (float) getYRot(partialTick);
@@ -66,10 +66,10 @@ public interface ICamera
         float x = MathHelper.sin(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
         float y = MathHelper.sin(-xRot * (MathHelper.PI / 180f));
         float z = MathHelper.cos(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
-        return Vec3d.createVector(x * xzLen, y, z * xzLen);
+        return Vec3.getTempVec3(x * xzLen, y, z * xzLen);
     }
 
-    default Vec3d getRotationVector(float partialTick)
+    default Vec3 getRotationVector(float partialTick)
     {
         double pitch = getXRot(partialTick);
         double yaw = getYRot(partialTick);
@@ -80,10 +80,10 @@ public interface ICamera
         float x = MathHelper.sin((float) (-yaw * toRads - Math.PI));
         float y = MathHelper.sin((float) (-pitch * toRads));
         float z = MathHelper.cos((float) (-yaw * toRads - Math.PI));
-        return Vec3d.createVector(x * xzLen, y, z * xzLen);
+        return Vec3.getTempVec3(x * xzLen, y, z * xzLen);
     }
 
-    default Vec3d getRotationVector()
+    default Vec3 getRotationVector()
     {
         return getRotationVector(1f);
     }
@@ -117,7 +117,7 @@ public interface ICamera
 
     default double distanceTo(double x, double y, double z, float partialTick)
     {
-        return MathHelper.sqrt_double(distanceToSqr(x, y, z, partialTick));
+        return MathHelper.sqrt(distanceToSqr(x, y, z, partialTick));
     }
 
     default double distanceTo(double x, double y, double z)
diff --git a/src/main/java/net/minecraft/client/render/canvas/CanvasMojangLogo.java b/src/main/java/net/minecraft/client/render/canvas/CanvasMojangLogo.java
index 05aee87a8..f0ffac4a2 100644
--- a/src/main/java/net/minecraft/client/render/canvas/CanvasMojangLogo.java
+++ b/src/main/java/net/minecraft/client/render/canvas/CanvasMojangLogo.java
@@ -17,7 +17,7 @@ public class CanvasMojangLogo extends Canvas
     {
         try
         {
-            logo = ImageIO.read((PanelCrashReport.class).getResource("/assets/minecraft/textures/gui/logo.png"));
+            logo = ImageIO.read((PanelCrashReport.class).getResource("/assets/minecraft/textures/gui/title/mclogo.png"));
         }
         catch(IOException ioexception) { }
         byte byte0 = 100;
diff --git a/src/main/java/net/minecraft/client/render/culling/Frustum.java b/src/main/java/net/minecraft/client/render/culling/Frustum.java
index c22033521..31d990abb 100644
--- a/src/main/java/net/minecraft/client/render/culling/Frustum.java
+++ b/src/main/java/net/minecraft/client/render/culling/Frustum.java
@@ -43,8 +43,8 @@ public class Frustum extends FrustumData
         _proj.clear();
         _modl.clear();
         _clip.clear();
-        GL11.glGetFloat(GL11.GL_PROJECTION_MATRIX, _proj);
-        GL11.glGetFloat(GL11.GL_MODELVIEW_MATRIX, _modl);
+        GL11.glGetFloatv(GL11.GL_PROJECTION_MATRIX, _proj);
+        GL11.glGetFloatv(GL11.GL_MODELVIEW_MATRIX, _modl);
         _proj.flip().limit(16);
         _proj.get(projectionMatrix);
         _modl.flip().limit(16);
